// TRAINMOD events //

// INPUTS
registerInputEvent("fxDTSBrick", "onTrainDetected", "Self fxDTSBrick" TAB "Train Player" TAB "MiniGame MiniGame", 0);
registerInputEvent("fxDTSBrick", "onTrainFirstDetected", "Self fxDTSBrick" TAB "Train Player" TAB "MiniGame MiniGame", 0);
//registerInputEvent("fxDTSBrick", "onTrainSpawn", "Self fxDTSBrick" TAB "Train Player" TAB "MiniGame MiniGame", 0);

// OUTPUTS
registerOutputEvent("Player", "TrainMode", "list Neutral 0 Forward 1 Reverse 2 Brake 3 SoundHorn 1337", 0);
registerOutputEvent("fxDTSBrick", "TrainMode", "list Neutral 0 Forward 1 Reverse 2 Brake 3 SoundHorn 1337", 0);
registerOutputEvent("Player", "setTrainLocked", "bool", 0);
registerOutputEvent("fxDTSBrick", "setTrainLocked", "bool", 0);
registerOutputEvent("Player", "TrainTurn", "float -90 90 1.25 0", 0);
registerOutputEvent("fxDTSBrick", "TrainTurn", "float -90 90 1.25 0", 0);
registerOutputEvent("Player", "TrainLoopTurn", "string 10 40\tstring 10 40\tstring 10 40\tbool", 0);
registerOutputEvent("Player", "CenterTrain", "", 0);


// FUNCTIONS
function Player::TrainMode(%this,%arg) {
    if(%this.isTrain != 1) {
        return;
    }
    
    // horn
    if(%arg == 1337) {
        if(%this.hornsound !$= 0) {
            serverPlay3D(%this.hornsound,%this.getposition());
        }
        return;
    }
    
    // engine
    if(%arg == 0) {
        %this.enginestatus = 0;
        if(%this.playenginesound == 3) {
            %this.playenginesound = 1;
        }
    }
    
    if(%arg == 1) {
        if(%this.hasengine == 1) {
            %this.enginestatus = 1;
            if(%this.playenginesound == 4) {
                %this.playenginesound = 2;
            }
            %this.lastrotbrick = 0;
        }
    }
    
    if(%arg == 2) {
        if(%this.hasengine == 1) {
            %this.enginestatus = 2;
            %this.lastrotbrick = 0;
            if(%this.playenginesound == 4) {
                %this.playenginesound = 2;
            }
        }
    }
    
    if(%arg == 3) {
        if(%this.hasbrakes == 1 && $Pref::Trains::Brakes == 1) {
            %this.enginestatus = 3;
            if(%this.playenginesound >= 3) {
                %this.playenginesound = 0;
            }
        }
    }
}

function fxDTSBrick::TrainMode(%brick,%arg) {
    
    %this = %brick.vehicle;
    
    if(!isObject(%this)) {
        return;
    }
    
    if(%this.isTrain != 1) {
        return;
    }
    
    // horn
    if(%arg == 1337) {
        if(%this.hornsound !$= 0) {
            serverPlay3D(%this.hornsound,%this.getposition());
        }
        return;
    }
    
    // engine
    if(%arg == 0) {
        %this.enginestatus = 0;
        if(%this.playenginesound >= 1) {
            %this.playenginesound = -1;
        }
    }
    
    if(%arg == 1) {
        if(%this.hasengine == 1) {
            %this.enginestatus = 1;
            if(%this.playenginesound <= 0) {
                %this.playenginesound = 1;
            }
            %this.lastrotbrick = 0;
        }
    }
    
    if(%arg == 2) {
        if(%this.hasengine == 1) {
            %this.enginestatus = 2;
            %this.lastrotbrick = 0;
            if(%this.playenginesound <= 0) {
                %this.playenginesound = 1;
            }
        }
    }
    
    if(%arg == 3) {
        if(%this.hasbrakes == 1 && $Pref::Trains::Brakes == 1) {
            %this.enginestatus = 3;
            if(%this.playenginesound >= 1) {
                %this.playenginesound = 0;
            }
        }
    }
}

function AIPlayer::setTrainLocked(%this,%arg)
{
    %this.trainLocked = %arg;
}

function fxDTSBrick::setTrainLocked(%brick,%arg)
{
    %this = %brick.vehicle;
    
    if(!isObject(%this)) {
        return;
    }
    
    %this.trainLocked = %arg;
}

function AIPlayer::TrainTurn(%this,%arg)
{
    TrainTurn(%this, %arg, -1);
}

function fxDTSBrick::TrainTurn(%brick,%arg)
{
    %this = %brick.vehicle;
    
    if(!isObject(%this)) {
        return;
    }
    
    // rotate
    TrainTurn(%this, %arg, -1);
}

function AIPlayer::TrainLoopTurn(%this, %value, %interval, %ammount, %startnow)
{
	%value = limitNumber(%value *1, -90, 90);
	%interval = limitNumber(%interval *1, 16, 1000);
	%ammount = limitNumber(%ammount *1, 0, 500);
	
	cancel(%this.trainLoopTurn_schedulenoquota);
	
	if(%startnow)
		TrainLoopTurn_Loop(%this, %value, %interval, %ammount);
	else
		%this.trainLoopTurn_schedulenoquota = schedulenoquota(%interval, 0, TrainLoopTurn_Loop, %this, %value, %interval, %ammount-1);
}

function TrainLoopTurn_Loop(%train, %value, %interval, %ammount)
{
	if(!isObject(%train) || %ammount <= 0)
		return;
	TrainTurn(%train, %value, -1);
	cancel(%train.trainLoopTurn_schedulenoquota);
	%train.trainLoopTurn_schedulenoquota = schedulenoquota(%interval, 0, TrainLoopTurn_Loop, %train, %value, %interval, %ammount-1);
}

function limitNumber(%num, %min, %max)
{
	%num = (%num > %max ? %max : %num);
	%num = (%num < %min ? %min : %num);
	return %num;
}


function AIPlayer::CenterTrain(%this)
{
    
    %track = %this.curtrack;    
    if(%this.curtrack.getDatablock().getName() !$= "brickTrainGuideS")
        return;
    %box = %this.curtrack.getWorldBox();
    %lenx = getWord(%box, 0) - getWord(%box, 3);
    %leny = getWord(%box, 1) - getWord(%box, 4);
    %axis = %lenx < %leny;
    %center = getWord(%this.curtrack.getWorldBoxCenter(), %axis);
    %transform = %this.getTransform();
    if(%axis == 0)
        %newtrans = %center SPC getwords(%transform, 1, 6);
    else
        %newtrans = getword(%transform, 0) SPC %center SPC getwords(%transform, 2, 6);
    trainsdebug("\c6Center train - old transform \c4" @ %transform @ "\c6, new transform \c4" @ %newtrans @ "\c6, axis \c4" @ %axis @ "\c6, center \c4" @ %center);

    %this.setTransform(%newtrans);
}